/***********************************************************
 * $Id: fancybase.h 1106 2014-01-07 21:45:44Z fancylibs $
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

/****************************************************************************
**
** Author: Wolfgang Glas / EV-i
**
** Global ABI stuff.
** 
*****************************************************************************/

#ifndef FANCYBASE_H
#define FANCYBASE_H

#define FANCYLIBS_ABI 3

#ifdef WIN32
# ifdef __GNUC__
#  ifdef BUILD_fancybase3_DLL
#   define FANCYBASE_API __attribute__((dllexport))
#  else
#   define FANCYBASE_API __attribute__((dllimport))
#  endif
# else
#  ifdef BUILD_fancybase3_DLL
#   define FANCYBASE_API __declspec(dllexport)
#  else
#   define FANCYBASE_API __declspec(dllimport)
#  endif
# endif
#else
# ifdef __GNUC__
#  define FANCYBASE_INTERNAL_API __attribute__((visibility("hidden")))
# endif
#endif

#ifndef FANCYBASE_INTERNAL_API
#define FANCYBASE_INTERNAL_API
#endif

#ifndef FANCYBASE_API
#define FANCYBASE_API
#endif

#endif // ! FANCYBASE_H
