/*
 * fancyendian.h
 *
 *  Created on: 13.01.2017
 *      Author: bweber
 */

#ifndef FANCYENDIAN_H_
#define FANCYENDIAN_H_

#ifdef FANCY_SWAP_NETWORK_BYTE_ORDER
#  undef FANCY_SWAP_NETWORK_BYTE_ORDER
#endif

#ifdef WIN32
#  if defined ( _X86_ ) || defined ( __x86_64 )

#    define FANCY_SWAP_NETWORK_BYTE_ORDER

#    define LITTLE_ENDIAN	1234
#    define	BIG_ENDIAN	4321
#    define	PDP_ENDIAN	3412
#    define	BYTE_ORDER	LITTLE_ENDIAN

#    define htobe16(x) ((x << 8) | (x >> 8))
#    define htole16(x) (x)
#    define be16toh(x) ((x << 8) | (x >> 8))
#    define le16toh(x) (x)

#    define htobe32(x) __builtin_bswap32 (x)
#    define htole32(x) (x)
#    define be32toh(x) __builtin_bswap32 (x)
#    define le32toh(x) (x)

#    define htobe64(x) __builtin_bswap64 (x)
#    define htole64(x) (x)
#    define be64toh(x) __builtin_bswap64 (x)
#    define le64toh(x) (x)

#  else
#    error "Cannot determine Windows byte order on non-X86 architecture."
#  endif

#else
#  include <endian.h>
#  if __BYTE_ORDER == __LITTLE_ENDIAN
#    define FANCY_SWAP_NETWORK_BYTE_ORDER
#  endif
#endif

#endif /* FANCYENDIAN_H_ */
