/***********************************************************
 * $Id: fancyrunnable.h 1231 2014-05-01 20:15:35Z fancylibs $
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#include <fancyobject.h>

#ifndef FANCYRUNNABLE_H_
#define FANCYRUNNABLE_H_

namespace Fancy {

/**
 * An interface for a general runnable object with a bare @c run() method.
 */
class FANCYBASE_API Runnable : virtual public Object {
public:
    typedef ObjPtr<Runnable> ptr_t;

    virtual void run() = 0;

    /**
     * Optional. Useful for fast clean stopping, i.e. mass-interruption by worker thread pools or the like.
     */
    virtual void requestInterruption();

protected:
    Runnable() {}
    virtual ~Runnable();
};

}

#endif /* FANCYRUNNABLE_H_ */
